<?php
//
//UTF8 Fixer
//
//Saanina !
//phpbbarabia.com !
//
//23-3-2009


header('Expires: Thu, 21 Jul 1977 07:30:00 GMT');
header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
header('Cache-Control: post-check=0, pre-check=0', false);
header('Pragma: no-cache');	
header('Content-type: text/html; charset=utf-8');



if(!function_exists('scandir'))
{
	//aryel at redtwilight dot com dot br
	//http://www.php.net/manual/en/function.scandir.php#73062
	function scandir($dir,$listDirectories=false, $skipDots=true) 
	{
		$dirArray = array();
		if ($handle = opendir($dir)) 
		{
			while (false !== ($file = readdir($handle)))
			{
				if (($file != "." && $file != "..") || $skipDots == true)
				{
					if($listDirectories == false) 
					{
						if(is_dir($file)) 
						{
							continue; 
						} 
					}
					array_push($dirArray, basename($file));
				}
			}
			closedir($handle);
		}
		return $dirArray;
	}
}
//http://www.php.net/manual/en/function.scandir.php#88006
function getDirectoryTree($outer_dir)
{
    $dirs = array_diff(scandir($outer_dir), array('.', '..'));
    $dir_array = array();

	foreach($dirs as $d)
	{
        if(is_dir($outer_dir . '/' . $d))
		{
			if(!in_array($d, array('cache', 'store', 'files', 'docs')))
			{
				$dir_array[$outer_dir . '/' . $d] = getDirectoryTree($outer_dir . '/' . $d);
			}
		}
		else
		{
			if(strpos($d, '.html') !== false || strpos($d, '.php') !== false && basename(__file__) != $d)
			{
				$dir_array[$outer_dir . '/' . $d] = $d;
			}
		}
	}
    return $dir_array;
} 

function get_options_s($ar)
{
	if(!is_array($ar))
	{
		return;
	}
	
	foreach($ar as $t=>$g)
	{	
		if(is_array($g))
		{
			get_options_s($g);
		}
		else
		{
			echo '<option value="' . $t . '">' . $t . '</option>' . "\n";
		}
	}
}

//submit
if(isset($_POST['fix_it']))
{
	$filename = str_replace('..', '', $_POST['file_to_fix']);
	$file_folder = str_replace(basename($filename), '', $filename);

	if (!$handle = @fopen($filename, 'r'))
	{
		echo '<h2 style="color:red">Cannot open file ( ' . $filename . ' )</h2>';
		exit;
	}
	
	$contents = @fread($handle, filesize($filename));
	@fclose($handle);
	
	$begin_v = substr($contents, 0, 3);
	
	if($begin_v == pack("CCC", 0xef,0xbb,0xbf) || bin2hex($begin_v) == 'efbbbf' || $begin_v == '?')
	{
		$md5 = md5($contents);
		if(is_writable($file_folder))
		{
			$contents = substr($contents, 3);
			//$contents = str_replace("\xef\xbb\xbf", '', $contents);
			$md5_m2 = md5($contents);
			if($md5 != $md5_m2)
			{
				if (!$handle = @fopen($filename, 'w+'))
				{
					echo '<h2 style="color:red">Cannot open file ( ' . $filename . ' )</h2>';
					exit;
				}
			
				if (fwrite($handle, $contents) === false)
				{
					echo '<h2 style="color:red">Cannot write to file  ( ' . $filename . ' )</h2>';
					@fclose($handle);
					exit;
				}
			}
			
			echo '<h2 style="color:green">GOOD, We removed the BOM successfully ..</h2>';
		}
		else
		{
			echo '<h2 style="color:red">Yes, this file contains BOM, but file is not writable, give this file writable premission to fix it !..</h2>';
		}
	}
	else
	{
		echo '<h2 style="color:green">No, this file ( ' . $filename . ' ) doesn\'t have BOM ..</h2>';
	}
	
	@fclose($handle);
	
	echo '<br /><a href="' . basename(__file__) . '">return</a>';
	exit;
}


$dir    = '.';
$files = getDirectoryTree($dir);

echo '<html><head><title>UTF8 Fixer, phpBBArabia.com</title></head><body>';
echo '<h2>Choose the file you think it\'s contain UTF8 BOM to fix it ..</h2><br />' . "\n";
echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="post">' . "\n";
echo '<select name="file_to_fix">' . "\n";
	get_options_s($files) .  "\n";
echo '</select>' . "\n";
echo '<br />' . "\n";
echo '<input type="submit" name="fix_it" value="fix this file" />' . "\n";
echo '</form>' . "\n";
echo '<br />' . "\n";
echo '<br />' . "\n";
echo '<br />' . "\n";
echo 'Done by Saanina,  <a href="http://phpbbarabia.com">phpBBArabia.com</a>, <a href="http://moffed.com">Moffed.com</a>' . "\n";

//end of file !